@ECHO OFF
rem Wir befinden uns unter einem (Nicht-)MS-DOS
rem
rem PKB      enthaelt den Pfad, in dem DOS installiert ist
rem PKB_MODE enthaelt die auszufuehrende Patch-Aktion
rem RETURN   enthaelt die Ruecksprungadresse fuer GOTO

:start
CLS
ECHO.
ECHO Betriebssystem ist ein (Nicht-)MS-DOS
ECHO.
ECHO Der Tastaturtreiber bzw. das Tastaturlayout eines Nicht-MS-DOS-Systems laesst
ECHO sich (noch) nicht patchen. Sie haben aber die Moeglichkeit, einen alternativen
ECHO Treiber zu installieren. Er ist wegen seiner geringen Groesse auch fuer
ECHO MS-DOS-Nutzer interessant.
ECHO.
ECHO Nachteile dieses Treibers:
ECHO - Er unterstuetzt NUR das deutsche Layout
ECHO - Er unterstuetzt NUR die CapsLock-(EDV-)Funktion, kein ShiftLock
ECHO - Eine 100prozentige Kompatibilitaet kann nicht garantiert werden.
ECHO - Eine manuelle Aenderung der Konfigurationsdateien (AUTOEXEC.BAT und
ECHO   CONFIG.SYS) ist noetig (lesen Sie dazu die Installationshinweise oder
ECHO   die Datei .\LIESMICH.TXT)
ECHO.
ECHO Wie moechten Sie die Tastatur belegen?
ECHO 1 - Punkt auf dem Nummernblock
ECHO 2 - Komma auf dem Nummernblock
ECHO.
ECHO 9 - Installationshinweise
ECHO.
ECHO 0 - Programm beenden
..\PKBTools\CHOICE.EXE /c:1290
IF ERRORLEVEL 4 GOTO :ende
IF ERRORLEVEL 3 GOTO :hilfe
IF ERRORLEVEL 2 GOTO :komma
IF ERRORLEVEL 1 GOTO :punkt
ECHO Unerwarteter Fehler, keine Aktion ausgefuehrt.
GOTO :ende

:komma
rem Der alternative Treiber MiniKey mit Komma soll installiert werden.
SET pkb_mode=komma
SET return=patch_it
GOTO :getpath

:punkt
rem Der alternative Treiber MiniKey mit Punkt soll installiert werden.
SET pkb_mode=punkt
SET return=patch_it
GOTO :getpath

:patch_it
rem Pruefe, ob das angegebene Verzeichnis ueberhaupt vorhanden ist:
IF NOT EXIST %pkb%\NUL GOTO :nodir
rem Alles klar, kopiere den entsprechenden Treiber:
IF "%pkb_mode%" == "komma" COPY .\MINIKEYK.SYS %pkb% > NUL
IF "%pkb_mode%" == "punkt" COPY .\MINIKEYP.SYS %pkb% > NUL
SET pkb_mode=
SET return=
ECHO.
ECHO Kopieren durchgefuehrt. Bitte beachten Sie die Installationshinweise!
ECHO.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
GOTO :start

:getpath
rem Haben wir den DOS-Pfad schon?
IF NOT "%pkb%" == "" GOTO :%return%
ECHO.
ECHO Bitte geben Sie an, wo DOS installiert ist (Bitte zweimal ENTER druecken):
ECHO Beispiel C:\DOS
..\PKBTools\Key2Env Kompletter_Pfad:_ pkb setpath.bat
rem Belege die Variable pkb mit dem Pfad:
CALL SETPATH.BAT
DEL SETPATH.BAT > NUL
GOTO :%return%

:nodir
rem Das angegebene Verzeichnis wurde nicht gefunden.
ECHO.
ECHO FEHLER!
ECHO Das angegebene Verzeichnis wurde nicht gefunden - keine Aktion durchgefuehrt.
ECHO.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
SET pkb=
SET pkb_mode=
SET return=
GOTO :start

:hilfe
CLS
ECHO.
ECHO Hinweise zur Benutzung des Tastaturtreibers MiniKey
ECHO Dieser Text existiert auch als separate Datei: .\Liesmich.txt
ECHO.
ECHO PatchKeyboard hat in das von Ihnen angegebene Verzeichnis
ECHO %pkb%
ECHO die Datei MINIKEYK.SYS bzw. MINIKEYP.SYS kopiert (K und P stehen fuer die
ECHO Belegung der Taste auf dem Nummernblock; Komma oder Punkt).
ECHO.
ECHO Damit Sie diesen Treiber nutzen koennen, muessen Sie ihn im System eintragen:
ECHO Oeffnen Sie die Datei C:\AUTOEXEC.BAT mit einem Texteditor (z.B. EDIT.COM) und
ECHO suchen Sie nach folgendem Eintrag (Gross- und Kleinschreibung spielen dabei
ECHO keine Rolle):
ECHO KEYB GR,,KEYBOARD.SYS     oder     KEYB GR,,KEYBRD2.SYS
ECHO Sowohl vor KEYB als auch KEYBOARD.SYS koennte noch eine Pfadangabe stehen, das
ECHO ist in unserem Fall nicht von Bedeutung. Haben Sie diese Zeile gefunden,
ECHO schreiben Sie das Wort REM (fuer Remark, Kommentar) davor, speichern und
ECHO verlassen Sie die Datei. Damit wird diese Zeile beim naechsten Start von DOS
ECHO nicht ausgefuehrt.
ECHO Sollten Sie eine solche oder aehnliche Zeile nicht gefunden haben, wird Ihr
ECHO Tastaturtreiber vermutlich in der Datei C:\CONFIG.SYS geladen. Diese nehmen
ECHO wir uns nun ohnehin vor.
ECHO.
ECHO Druecken Sie eine beliebige Taste fuer die zweite Seite
PAUSE
CLS
ECHO.
ECHO Oeffnen Sie nun die Datei C:\CONFIG.SYS. Wenn Sie in der C:\AUTOEXEC.BAT den
ECHO Treiber schon auskommentiert haben, ueberspringen Sie den naechsten Absatz.
ECHO.
ECHO Suchen Sie nach folgender oder aehnlicher Zeile:
ECHO DEVICE=KEYBOARD.SYS
ECHO Je nach DOS-Variante kann dort auch DEVICEHIGH, ein Pfad vor KEYBOARD.SYS oder
ECHO ein anderer Name stehen (der aber, auch wenn verkuerzt, immer noch an KEYBOARD
ECHO erinnern wird), ausserdem koennten noch Parameter (beginnend mit / oder -)
ECHO vorkommen. Haben Sie diese Zeile gefunden, schreiben Sie ein REM davor.
ECHO.
ECHO Nun wieder fuer alle:
ECHO Fuegen Sie eine neue Zeile ein, die den MiniKey-Treiber referenziert:
ECHO DEVICE=%pkb%\MINIKEYP.SYS  bzw.
ECHO DEVICE=%pkb%\MINIKEYK.SYS
ECHO Wenn Sie wegen der Syntax unsicher sind, orientieren Sie sich an der zuvor
ECHO auskommentierten Zeile in dieser Datei (falls Sie das getan haben).
ECHO Sie koennen allerdings alle Parameter weglassen.
ECHO.
ECHO Speichern Sie wieder, verlassen den Editor und starten Sie Ihren Rechner neu.
ECHO.
ECHO Druecken Sie eine beliebige Taste fuer die dritte Seite
PAUSE
CLS
ECHO.
ECHO Beim Hochfahren von DOS sollte nun (unter anderem) die folgende Meldung
ECHO erscheinen:
ECHO.
ECHO  Tastaturtreiber MiniKey (Punkt-Patch) geladen ...
ECHO.
ECHO Wenn Sie MINIKEYK.SYS installiert haben, steht in Klammern natuerlich Komma.
ECHO Damit ist die Installation abgeschlossen.
ECHO.
ECHO Auf Problemfaelle werde ich hier nicht eingehen, da sie aufgrund der vielen
ECHO verschiedenen Moeglichkeiten den Rahmen sprengen wuerden. Wenden Sie sich im
ECHO Notfall an einen versierten Bekannten.
ECHO.
ECHO Viel Erfolg!
ECHO.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
GOTO :start

:ende
CD ..
SET pkb=
SET pkb_mode=
SET return=
