:start
rem Wir sind in DOS und wollen Windows 3.x patchen
rem Benutzte Umgebungsvariablen:
rem
rem PKB      enthaelt den Pfad, in dem Windows installiert ist
rem PKB_MODE enthaelt die auszufuehrende Patch-Aktion
rem RETURN   enthaelt die Ruecksprungadresse fuer GOTO

CLS
ECHO Gewaehltes Betriebssystem ist MS-Windows 3.x
ECHO.
ECHO Waehlen Sie das zu installierende Tastaturlayout aus. Es wird in Ihr
ECHO Windows-System-Verzeichnis kopiert.
ECHO.
ECHO 1 - Deutsch (Standard) mit Punkt auf Nummernblock
ECHO 2 - Deutsch (EDV) mit Komma auf Nummernblock
ECHO 3 - Deutsch (EDV) mit Punkt auf Nummernblock
ECHO 4 - Alle zuvor genannten
ECHO.
ECHO 9 - Hilfe zur Benutzung der Layouts unter Windows 3.x anzeigen
ECHO.
ECHO 0 - Zurueck zum Hauptmenue
..\PKBTools\CHOICE.EXE /c:123490
IF ERRORLEVEL 6 GOTO :ende
IF ERRORLEVEL 5 GOTO :hilfe
IF ERRORLEVEL 4 GOTO :alle
IF ERRORLEVEL 3 GOTO :edvpunkt
IF ERRORLEVEL 2 GOTO :edvkomma
IF ERRORLEVEL 1 GOTO :stdpunkt
ECHO Unerwarteter Fehler, keine Aktion ausgefuehrt.
GOTO :ende

:alle
rem Kopiert alle Layouts in das Systemverzeichnis von Windows 3.x.
SET return=patch_it
SET pkb_mode=alle
GOTO :getpath

:stdpunkt
rem Kopiert das Layout "Deutsch (Standard,Punkt)" in das Systemverzeichnis
rem von Windows 3.x.
SET return=patch_it
SET pkb_mode=stdpunkt
GOTO :getpath

:edvpunkt
rem Kopiert das Layout "Deutsch (EDV,Punkt)" in das Systemverzeichnis
rem von Windows 3.x.
SET return=patch_it
SET pkb_mode=edvpunkt
GOTO :getpath

:edvkomma
rem Kopiert das Layout "Deutsch (EDV,kein Punkt)" in das Systemverzeichnis
rem von Windows 3.x.
SET return=patch_it
SET pkb_mode=edvkomma
GOTO :getpath

:patch_it
rem Pruefe, ob die Datei ueberhaupt vorhanden ist:
IF NOT EXIST %pkb%\SYSTEM\SETUP.INF GOTO :nofile
rem SETUP.INF ist vorhanden. Kopiere nun den entsprechenden Treiber:
IF "%pkb_mode%" == "edvkomma" COPY .\KBDGR1.DLL %pkb%\SYSTEM > NUL
IF "%pkb_mode%" == "stdpunkt" COPY .\KBDGR10.DLL %pkb%\SYSTEM > NUL
IF "%pkb_mode%" == "edvpunkt" COPY .\KBDGR11.DLL %pkb%\SYSTEM > NUL
IF "%pkb_mode%" == "alle" COPY .\KBD*.DLL %pkb%\SYSTEM > NUL
rem Erstelle neue SYSTEM\SETUP.INF (es werden immer alle Layouts eingetragen):
..\PKBTools\WIN3PKB %pkb%
rem Teste, ob das Patchen ueberhaupt erfolgt ist (also noetig war).
rem Wenn nicht, darf die schon gepatchte SETUP.INF nicht nochmal ins Backup:
IF NOT EXIST %pkb%\SYSTEM\SETUP.ROB GOTO :patch_2
rem Ja, also ersetze die originale SETUP.INF durch die gepatchte Version
rem und behalte das Original als Sicherheitskopie unter dem Namen SETUP.PKB
REN %pkb%\SYSTEM\SETUP.INF SETUP.PKB > NUL
REN %pkb%\SYSTEM\SETUP.ROB SETUP.INF > NUL
:patch_2
ECHO.
ECHO Um das Layout nutzen zu koennen, lesen Sie bitte die Hinweise in der Datei
ECHO .\Liesmich.txt oder im Menue (Nummer 9)
PAUSE
SET return=
SET pkb_mode=
GOTO :start

:nofile
rem Die Windows-Datei SETUP.INF wurde nicht gefunden.
ECHO.
ECHO FEHLER!
ECHO Die Datei mit den Layoutinformationen wurde nicht gefunden - keine Aktion
ECHO durchgefuehrt.
ECHO Stellen Sie sicher, dass Sie den richtigen Pfad (samt Laufwerk) eingegeben
ECHO haben. Evtl. existiert auch die zu patchende Datei SETUP.INF nicht in
ECHO diesem Pfad.
ECHO.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
SET pkb=
SET pkb_mode=
SET return=
GOTO :start

:getpath
rem Haben wir den Windows-Pfad schon?
IF NOT "%pkb%" == "" GOTO :%return%
ECHO.
ECHO Bitte geben Sie an, wo Windows installiert ist (Bitte zweimal ENTER druecken):
ECHO Beispiel C:\Windows
..\PKBTools\Key2Env Kompletter_Pfad:_ pkb setpath.bat
rem Belege die Variable pkb mit dem Pfad:
CALL SETPATH.BAT
DEL SETPATH.BAT > NUL
GOTO :%return%

:hilfe
CLS
ECHO.
ECHO Hinweise zur Benutzung der Tastaturlayouts in Windows 3.x
ECHO Dieser Text existiert auch als separate Datei: .\Liesmich.txt
ECHO.
ECHO Ihre Tastaturlayoutauswahl wurde um drei neue Layouts erweitert, auch wenn
ECHO Sie nur ein Layout ausgewaehlt haben - in diesem Fall wurde dann auch nur das
ECHO gewaehlte Layout physikalisch kopiert.
ECHO Sie finden die neuen Layouts in Windows unter
ECHO.
ECHO Systemsteuerung - Laendereinstellungen - Tastaturlayout
ECHO.
ECHO Waehlen Sie nun eines der neuen Layouts. Windows fordert daraufhin die
ECHO entsprechende Installationsdiskette an. Da die Datei zu diesem Zeitpunkt aber
ECHO schon im Systemverzeichnis existiert, geben Sie hier statt dessen Laufwerk
ECHO und Pfad Ihres Windows an.
ECHO Beispiel:
ECHO Angenommen, Windows ist installiert in C:\WINDOWS, dann geben Sie als Quelle
ECHO C:\WINDOWS\SYSTEM an.
ECHO.
ECHO Druecken Sie eine beliebige Taste fuer die zweite Seite.
PAUSE
CLS
ECHO.
ECHO Durch diese Aenderung wird uebrigens das Layout in einem DOS-Fenster NICHT
ECHO beeinflusst, da dort auf das Layout des zugrundeliegenden installierten DOS
ECHO zurueckgegriffen wird. Wollen Sie eine konsistente Tastenbelegung, muessen Sie
ECHO das Layout auch fuer Ihr DOS aendern (Menuepunkt MS-DOS).
ECHO.
ECHO.
ECHO Technischer Hinweis:
ECHO Um die neuen Layouts hinzufuegen zu koennen, musste die Datei
ECHO (Windows-Verzeichnis)\SYSTEM\SETUP.INF geaendert werden. Sie finden eine
ECHO Sicherheitskopie Ihrer originalen Datei unter dem Namen SETUP.PKB
ECHO.
ECHO Druecken Sie eine beliebige Taste, um zur Auswahl zurueckzukehren.
PAUSE
GOTO :start

:ende
CD ..
SET pkb_mode=
SET pkb=
SET return=
