@ECHO OFF
rem Wir sind in Windows NT 4.0
rem
rem Checken, ob der Benutzer Administrator-Rechte hat. Diese sind notwendig, um
rem Tastaturtreiber hinzuzufgen oder Registry-Eintraege fuer alle Benutzer zu
rem aendern. Die Erkennung laeuft nur ueber den Wert der Variablen "UserName".
rem Wenn der eingeloggte Benutzer nicht "administrator" heisst, werden ihm
rem dessen Moeglichkeiten vorenthalten. Da allerdings ein Benutzer trotzdem
rem Admin-Rechte haben kann, ist die Umgehung dieser Erkennung mit dem Aufruf
rem des Programms mit dem Parameter -admin moeglich. Das bedeutet aber
rem nicht, dass ein x-beliebiger Benutzer ohne Admin-Rechte nun doch alle
rem Aenderungen vornehmen kann - das laesst Windows nicht zu.

IF "%1" == "-NT4ADMIN" GOTO :admin
..\PKBTOOLS\PCASE.EXE %USERNAME% -upper pkb_user > SETUSER.BAT
CALL SETUSER.BAT
DEL SETUSER.BAT > NUL
IF "%pkb_user%" == "ADMINISTRATOR" GOTO :admin
GOTO :user

:user
rem Ein Benutzer ohne Admin-Rechte?
IF "%pkb_user%" == "-NT4ADMIN" GOTO :admin
CLS
ECHO.
ECHO Betriebssystem ist Windows NT 4.0
ECHO.
ECHO Es sieht so aus, als haetten Sie keine Administrator-Rechte, die noetig sind
ECHO um einen neuen Tastaturtreiber installieren zu koennen und andere globale
ECHO Einstellungen vorzunehmen.
ECHO.
ECHO Was wollen Sie tun? Bitte geben Sie die entsprechende Zahl an.
ECHO.
ECHO 1 - Ich habe die noetigen Rechte! (Zum Administrator-Modus)
ECHO.
ECHO 8 - Nur fuer mich: NumLock beim Start EINgeschaltet
ECHO 9 - Nur fuer mich: NumLock beim Start AUSgeschaltet
ECHO.
ECHO 0 - Programm beenden

..\PKBTools\CHOICE.EXE /c:1890
IF ERRORLEVEL 4 GOTO :ende
IF ERRORLEVEL 3 GOTO :unlaus
IF ERRORLEVEL 2 GOTO :unlein
IF ERRORLEVEL 1 GOTO :admin
ECHO Unerwarteter Fehler, keine Aktion ausgefuehrt.
GOTO :ende

:admin
rem Erweiterte Funktionen fuer Administratoren
SET pkb_user=-NT4ADMIN
CLS
ECHO.
ECHO Betriebssystem ist Windows NT 4.0
ECHO.
ECHO Als Administrator duerfen Sie weitreichende Aenderungen vornehmen.
ECHO.
ECHO Was wollen Sie tun? Bitte geben Sie die entsprechende Zahl an.
ECHO.
ECHO Tastaturtreiber installieren:
ECHO 1 - Deutsch (Standard) mit Punkt auf Nummernblock
ECHO 2 - Deutsch (IBM) mit Punkt auf Nummernblock
ECHO 3 - Fuer den Treiber Deutsch (Standard): CapsLock ueber Shift wieder
ECHO     ausschalten (ab ServicePack 4)
ECHO.
ECHO Tastenbelegung vor dem Einloggen (gilt fuer alle Benutzer):
ECHO 5 - Sprache waehlen
ECHO 6 - NumLock EINgeschaltet
ECHO 7 - NumLock AUSgeschaltet
ECHO.
ECHO 8 - Nur fuer mich: NumLock beim Start EINgeschaltet
ECHO 9 - Nur fuer mich: NumLock beim Start AUSgeschaltet
ECHO.
ECHO 0 - Programm beenden
..\PKBTools\CHOICE.EXE /c:123567890
IF ERRORLEVEL 9 GOTO :ende
IF ERRORLEVEL 8 GOTO :unlaus
IF ERRORLEVEL 7 GOTO :unlein
IF ERRORLEVEL 6 GOTO :anlaus
IF ERRORLEVEL 5 GOTO :anlein
IF ERRORLEVEL 4 GOTO :sprache
IF ERRORLEVEL 3 GOTO :stdshift
IF ERRORLEVEL 2 GOTO :ibmpunkt
IF ERRORLEVEL 1 GOTO :stdpunkt
ECHO Unerwarteter Fehler, keine Aktion ausgefuehrt.
GOTO :ende

:unlaus
rem User NumLock aus
rem Schaltet den Nummernblock fuer den aktuellen Benutzer initial aus
%windir%\REGEDIT /s .\NL_U_AUS.REG
ECHO Patch wurde fehlerfrei durchgefuehrt.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
rem Zurueck zum Menue
GOTO :user

:unlein
rem User NumLock ein
rem Schaltet den Nummernblock fuer den aktuellen Benutzer initial ein
%windir%\REGEDIT /s .\NL_U_EIN.REG
ECHO Patch wurde fehlerfrei durchgefuehrt.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
rem Zurueck zum Menue
GOTO :user

:anlaus
rem Alle User NumLock aus
rem Schaltet den Nummernblock fuer alle Benutzer initial aus
%windir%\REGEDIT /s .\NL_A_AUS.REG
ECHO Patch wurde durchgefuehrt.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
rem Zurueck zum Menue
GOTO :admin

:anlein
rem Alle User NumLock ein
rem Schaltet den Nummernblock fuer alle Benutzer initial ein
%windir%\REGEDIT /s .\NL_A_EIN.REG
ECHO Patch wurde durchgefuehrt.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
rem Zurueck zum Menue
GOTO :admin

:ibmpunkt
rem Fuer alle Benutzer: neues Layout "Deutsch (IBM, Punkt)"
rem Der entsprechende (DOS-)Treiber wird wegen des automatischen Schutz-
rem mechanismus von Windows NT noch nicht kopiert, daher kann es in
rem Einzelfaellen zu inkonsistenten Belegungen der Taste kommen (nur in einer
rem DOS-Box).
COPY .\KBDGR11.DLL %windir%\SYSTEM32\KBDGR11.DLL > NUL
%windir%\REGEDIT /s .\IBMPUNKT.REG
ECHO Patch wurde durchgefuehrt.
ECHO Sie muessen das Layout noch auswaehlen, wenn Sie es benutzen wollen.
ECHO Sie erreichen es ueber
ECHO "Start->Einstellungen->Systemsteuerung->Tastatur:Eingabe:Hinzufuegen"
ECHO.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
rem Rufe den Tastatur-Dialog auf:
%windir%\system32\control.exe keyboard
PAUSE
GOTO :admin

:stdpunkt
rem Fuer alle Benutzer: neues Layout "Deutsch (Punkt)"
rem Der entsprechende (DOS-)Treiber wird wegen des automatischen Schutz-
rem mechanismus von Windows NT noch nicht kopiert, daher kann es in
rem Einzelfaellen zu inkonsistenten Belegungen der Taste kommen (nur in einer
rem DOS-Box).
COPY .\KBDGR10.DLL %windir%\SYSTEM32\KBDGR10.DLL > NUL
%windir%\REGEDIT /s .\STDPUNKT.REG
ECHO Patch wurde durchgefuehrt.
ECHO Sie muessen das Layout noch auswaehlen, wenn Sie es benutzen wollen.
ECHO Sie erreichen es ueber
ECHO "Start->Einstellungen->Systemsteuerung->Tastatur:Eingabe:Hinzufuegen"
ECHO.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
rem Rufe den Tastatur-Dialog auf:
%windir%\system32\control.exe keyboard
PAUSE
GOTO :admin

:stdshift
rem Fuer den Deutsch (Standard) Treiber einstellen, dass er ueber Shift statt
rem ueber Caps ausgeschaltet wird (erst ab ServicePack 4)
%windir%\REGEDIT /s .\STDSHIFT.REG
ECHO Diese Aenderung betrifft NICHT die DOS-Anwendungen!
ECHO.
ECHO Patch wurde durchgefuehrt.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
GOTO :admin

:sprache
rem Fuer alle Benutzer: Sprachlayout vor dem Einloggen
rem Exportiere den Layout-Zweig der Registry:
%windir%\REGEDIT /e .\K_Layout.reg "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Keyboard Layouts"
CLS
..\PKBTOOLS\PRELANG.EXE K_Layout.reg PreLang.reg -win2k
IF ERRORLEVEL 2 GOTO :sprache2
IF ERRORLEVEL 1 GOTO :sprache1
rem Trage Aenderung in die Registry ein:
%windir%\REGEDIT /s .\PreLang.reg
rem Die temporaer angelegten Dateien werden nicht mehr gebraucht:
DEL .\K_Layout.reg > NUL
DEL .\PreLang.reg > NUL
ECHO Patch wurde durchgefuehrt.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
GOTO :admin

:sprache1
rem Dieser Fehler darf nie auftauchen:
ECHO Konnte die Eingabedatei (K_Layout.reg) nicht finden
ECHO (Dieser Fehler duerfte eigentlich nicht auftauchen...)
ECHO.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
PAUSE
GOTO :admin

:sprache2
rem Kann passieren: Der User hat ein Layout gewaehlt, das noch nicht im System
rem installiert ist:
ECHO.
ECHO Das von Ihnen gewaehlte Tastaturlayout ist noch nicht installiert. Bitte
ECHO installieren Sie es ueber
ECHO "Start->Einstellungen->Systemsteuerung->Tastatur:Eingabe:Hinzufuegen"
ECHO Dazu benoetigen Sie Ihre Windows-Installations-CD!
ECHO.
ECHO Druecken Sie eine beliebige Taste, um zum Menue zurueckzukehren.
rem Rufe den Tastatur-Dialog auf:
%windir%\system32\control.exe keyboard
PAUSE
GOTO :admin

:ende
CD ..
SET pkb_user=
